

/* ***********************************************************************
                Naval Air Warfare Center / Aircraft Division              
                        Patuxent Naval Air Station                         
 ========================================================================

        File:           mem_man.c                                         
                                                                        
        Classification: UNCLASSIFIED                                   
                                                                        
        Description:    This file contains the functions, methods, and
			global variables needed to manage the most
			frequently allocated memory classes/structs.
			
        Written by:	Alex Harper
*********************************************************************** */

#include "vissim.h"


vmem_manager vmemman(VMAXLISTS, MAXBUFFERS);


/* *************************************************
  Sets the string part of the label
************************************************* */
void labeltype::set_label(char *string) {

   label.stringcpy(string);
}


/* ============================================================================
  Allocates and returns an instance of the labeltype class
 ============================================================================ */
void *vmem_manager::pop(int item, int size) {

   dbl_llist *ptr;
   
   if (size)
      return memman::pop(item, size);
      
   if (listmem[item].head) {
      ptr = listmem[item].head;
      listmem[item].remove(ptr);
      return ptr;
   }

   switch (item) {  		// Allocates and returns an instance of the labeltype class

      case MM_LABEL:   
         return new labeltype;

//      case MM_LINE:		// Allocates an instance of linetype
      default:
         return new linetype;
   }
   	 
}

